clear all
Cl=0.06;
Cr=0.0155;
hr=75;                         %[nm]
x1=-hr:1:0;                    %[nm (nanometer)]
x2=0:1:500-hr;                     %[nm]
d=2*hr;                         %[nm]
t=1052*60;                      %[s]
D1=1.0*10^+1;                   %[nm/s]
D2=4.*10^-2;                   %[nm/s]
d1=D1*10^-18;                   %[m/s]
d2=D2*10^-18;                   %[m/s]
p=[sqrt(D1)*D2-sqrt(D2)*D1]/[sqrt(D1)*D2+sqrt(D2)*D1];

%Startkonzentrationen
x=zeros(1,502);
x(1:hr+1)=x1+hr*ones(1,length(x1));                
x(hr+2:end)=x2+hr*ones(1,length(x2));  

C=zeros(1,502);
C(1:hr+1)=Cl;                    %Mineral A
C(hr+2:end)=Cr;                  %Mineral B

%Plots start concentrations
figure(1)
plot(x,C,'black')
xlabel('Distance [nm]')
ylabel('Normalized Conc.')
axis([min(x) max(x) 0.01 0.065])
hold on

for i=1:length(x1)
    for n=1:100
        k1(i,n)=(-p)^(n-1)*(erf((d*n+x1(i))/(2*sqrt(D1*t)))-p*erf((d*n-x1(i))/(2*sqrt(D1*t))));
    end
    C1(i)=(-(1+p)*erf(x1(i)/(2*sqrt(D1*t)))+(1+p)*sum(k1(i,1:n)))*0.5;
end

for i=1:length(x2)
    for n=1:100
        k2(i,n)=(-p)^(n-1)*erf((d*sqrt(D2/D1)*n+x2(i))/(2*sqrt(D2*t)));
    end
    C2(i)=(-(1-p)*erf(x2(i)/(2*sqrt(D2*t)))+(1-p^2)*sum(k2(i,1:n)))*0.5;
end

C=zeros(1,502);
C(1:hr+1)=C1*(Cl-Cr)+Cr;                    %Mineral A
C(hr+2:end)=C2*(Cl-Cr)+Cr;                  %Mineral B

%figure(1)
plot(x,C,'red')